/* Software License Agreement (BSD License)
 *
 * Copyright (c) 2011, Willow Garage, Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *  * Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *  * Redistributions in binary form must reproduce the above
 *    copyright notice, this list of conditions and the following
 *    disclaimer in the documentation and/or other materials provided
 *    with the distribution.
 *  * Neither the name of Willow Garage, Inc. nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 * COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
 * ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 *
 * Auto-generated by genmsg_cpp from file /tmp/buildd/ros-hydro-wireless-msgs-0.0.2-0precise-20150326-2154/msg/Connection.msg
 *
 */


#ifndef WIRELESS_MSGS_MESSAGE_CONNECTION_H
#define WIRELESS_MSGS_MESSAGE_CONNECTION_H


#include <string>
#include <vector>
#include <map>

#include <ros/types.h>
#include <ros/serialization.h>
#include <ros/builtin_message_traits.h>
#include <ros/message_operations.h>


namespace wireless_msgs
{
template <class ContainerAllocator>
struct Connection_
{
  typedef Connection_<ContainerAllocator> Type;

  Connection_()
    : bitrate(0)
    , txpower(0)
    , link_quality_raw()
    , link_quality(0.0)
    , signal_level(0)
    , noise_level(0)  {
    }
  Connection_(const ContainerAllocator& _alloc)
    : bitrate(0)
    , txpower(0)
    , link_quality_raw(_alloc)
    , link_quality(0.0)
    , signal_level(0)
    , noise_level(0)  {
    }



   typedef int16_t _bitrate_type;
  _bitrate_type bitrate;

   typedef int16_t _txpower_type;
  _txpower_type txpower;

   typedef std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other >  _link_quality_raw_type;
  _link_quality_raw_type link_quality_raw;

   typedef float _link_quality_type;
  _link_quality_type link_quality;

   typedef int16_t _signal_level_type;
  _signal_level_type signal_level;

   typedef int16_t _noise_level_type;
  _noise_level_type noise_level;




  typedef boost::shared_ptr< ::wireless_msgs::Connection_<ContainerAllocator> > Ptr;
  typedef boost::shared_ptr< ::wireless_msgs::Connection_<ContainerAllocator> const> ConstPtr;
  boost::shared_ptr<std::map<std::string, std::string> > __connection_header;

}; // struct Connection_

typedef ::wireless_msgs::Connection_<std::allocator<void> > Connection;

typedef boost::shared_ptr< ::wireless_msgs::Connection > ConnectionPtr;
typedef boost::shared_ptr< ::wireless_msgs::Connection const> ConnectionConstPtr;

// constants requiring out of line definition



template<typename ContainerAllocator>
std::ostream& operator<<(std::ostream& s, const ::wireless_msgs::Connection_<ContainerAllocator> & v)
{
ros::message_operations::Printer< ::wireless_msgs::Connection_<ContainerAllocator> >::stream(s, "", v);
return s;
}

} // namespace wireless_msgs

namespace ros
{
namespace message_traits
{



// BOOLTRAITS {'IsFixedSize': False, 'IsMessage': True, 'HasHeader': False}
// {'std_msgs': ['/opt/ros/hydro/share/std_msgs/cmake/../msg'], 'wireless_msgs': ['/tmp/buildd/ros-hydro-wireless-msgs-0.0.2-0precise-20150326-2154/msg']}

// !!!!!!!!!!! ['__class__', '__delattr__', '__dict__', '__doc__', '__eq__', '__format__', '__getattribute__', '__hash__', '__init__', '__module__', '__ne__', '__new__', '__reduce__', '__reduce_ex__', '__repr__', '__setattr__', '__sizeof__', '__str__', '__subclasshook__', '__weakref__', '_parsed_fields', 'constants', 'fields', 'full_name', 'has_header', 'header_present', 'names', 'package', 'parsed_fields', 'short_name', 'text', 'types']




template <class ContainerAllocator>
struct IsFixedSize< ::wireless_msgs::Connection_<ContainerAllocator> >
  : FalseType
  { };

template <class ContainerAllocator>
struct IsFixedSize< ::wireless_msgs::Connection_<ContainerAllocator> const>
  : FalseType
  { };

template <class ContainerAllocator>
struct IsMessage< ::wireless_msgs::Connection_<ContainerAllocator> >
  : TrueType
  { };

template <class ContainerAllocator>
struct IsMessage< ::wireless_msgs::Connection_<ContainerAllocator> const>
  : TrueType
  { };

template <class ContainerAllocator>
struct HasHeader< ::wireless_msgs::Connection_<ContainerAllocator> >
  : FalseType
  { };

template <class ContainerAllocator>
struct HasHeader< ::wireless_msgs::Connection_<ContainerAllocator> const>
  : FalseType
  { };


template<class ContainerAllocator>
struct MD5Sum< ::wireless_msgs::Connection_<ContainerAllocator> >
{
  static const char* value()
  {
    return "023561cebec37b2f24b090d600c53fc2";
  }

  static const char* value(const ::wireless_msgs::Connection_<ContainerAllocator>&) { return value(); }
  static const uint64_t static_value1 = 0x023561cebec37b2fULL;
  static const uint64_t static_value2 = 0x24b090d600c53fc2ULL;
};

template<class ContainerAllocator>
struct DataType< ::wireless_msgs::Connection_<ContainerAllocator> >
{
  static const char* value()
  {
    return "wireless_msgs/Connection";
  }

  static const char* value(const ::wireless_msgs::Connection_<ContainerAllocator>&) { return value(); }
};

template<class ContainerAllocator>
struct Definition< ::wireless_msgs::Connection_<ContainerAllocator> >
{
  static const char* value()
  {
    return "int16 bitrate  # Mb/s\n\
int16 txpower  # dBm\n\
\n\
# Fractional link quality number preserved in raw\n\
# field, resolved to decimal for link_quality field.\n\
string link_quality_raw\n\
float32 link_quality\n\
\n\
int16 signal_level  # dBm\n\
int16 noise_level  # dBm\n\
";
  }

  static const char* value(const ::wireless_msgs::Connection_<ContainerAllocator>&) { return value(); }
};

} // namespace message_traits
} // namespace ros

namespace ros
{
namespace serialization
{

  template<class ContainerAllocator> struct Serializer< ::wireless_msgs::Connection_<ContainerAllocator> >
  {
    template<typename Stream, typename T> inline static void allInOne(Stream& stream, T m)
    {
      stream.next(m.bitrate);
      stream.next(m.txpower);
      stream.next(m.link_quality_raw);
      stream.next(m.link_quality);
      stream.next(m.signal_level);
      stream.next(m.noise_level);
    }

    ROS_DECLARE_ALLINONE_SERIALIZER;
  }; // struct Connection_

} // namespace serialization
} // namespace ros

namespace ros
{
namespace message_operations
{

template<class ContainerAllocator>
struct Printer< ::wireless_msgs::Connection_<ContainerAllocator> >
{
  template<typename Stream> static void stream(Stream& s, const std::string& indent, const ::wireless_msgs::Connection_<ContainerAllocator>& v)
  {
    s << indent << "bitrate: ";
    Printer<int16_t>::stream(s, indent + "  ", v.bitrate);
    s << indent << "txpower: ";
    Printer<int16_t>::stream(s, indent + "  ", v.txpower);
    s << indent << "link_quality_raw: ";
    Printer<std::basic_string<char, std::char_traits<char>, typename ContainerAllocator::template rebind<char>::other > >::stream(s, indent + "  ", v.link_quality_raw);
    s << indent << "link_quality: ";
    Printer<float>::stream(s, indent + "  ", v.link_quality);
    s << indent << "signal_level: ";
    Printer<int16_t>::stream(s, indent + "  ", v.signal_level);
    s << indent << "noise_level: ";
    Printer<int16_t>::stream(s, indent + "  ", v.noise_level);
  }
};

} // namespace message_operations
} // namespace ros

#endif // WIRELESS_MSGS_MESSAGE_CONNECTION_H
