/* Software License Agreement (BSD License)
 *
 * Copyright (c) 2011, Willow Garage, Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *  * Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *  * Redistributions in binary form must reproduce the above
 *    copyright notice, this list of conditions and the following
 *    disclaimer in the documentation and/or other materials provided
 *    with the distribution.
 *  * Neither the name of Willow Garage, Inc. nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 * COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
 * ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 *
 * Auto-generated by genmsg_cpp from file /tmp/buildd/ros-hydro-wireless-msgs-0.0.2-0precise-20150326-2154/msg/Scan.msg
 *
 */


#ifndef WIRELESS_MSGS_MESSAGE_SCAN_H
#define WIRELESS_MSGS_MESSAGE_SCAN_H


#include <string>
#include <vector>
#include <map>

#include <ros/types.h>
#include <ros/serialization.h>
#include <ros/builtin_message_traits.h>
#include <ros/message_operations.h>

#include <wireless_msgs/Network.h>

namespace wireless_msgs
{
template <class ContainerAllocator>
struct Scan_
{
  typedef Scan_<ContainerAllocator> Type;

  Scan_()
    : networks()  {
    }
  Scan_(const ContainerAllocator& _alloc)
    : networks(_alloc)  {
    }



   typedef std::vector< ::wireless_msgs::Network_<ContainerAllocator> , typename ContainerAllocator::template rebind< ::wireless_msgs::Network_<ContainerAllocator> >::other >  _networks_type;
  _networks_type networks;




  typedef boost::shared_ptr< ::wireless_msgs::Scan_<ContainerAllocator> > Ptr;
  typedef boost::shared_ptr< ::wireless_msgs::Scan_<ContainerAllocator> const> ConstPtr;
  boost::shared_ptr<std::map<std::string, std::string> > __connection_header;

}; // struct Scan_

typedef ::wireless_msgs::Scan_<std::allocator<void> > Scan;

typedef boost::shared_ptr< ::wireless_msgs::Scan > ScanPtr;
typedef boost::shared_ptr< ::wireless_msgs::Scan const> ScanConstPtr;

// constants requiring out of line definition



template<typename ContainerAllocator>
std::ostream& operator<<(std::ostream& s, const ::wireless_msgs::Scan_<ContainerAllocator> & v)
{
ros::message_operations::Printer< ::wireless_msgs::Scan_<ContainerAllocator> >::stream(s, "", v);
return s;
}

} // namespace wireless_msgs

namespace ros
{
namespace message_traits
{



// BOOLTRAITS {'IsFixedSize': False, 'IsMessage': True, 'HasHeader': False}
// {'std_msgs': ['/opt/ros/hydro/share/std_msgs/cmake/../msg'], 'wireless_msgs': ['/tmp/buildd/ros-hydro-wireless-msgs-0.0.2-0precise-20150326-2154/msg']}

// !!!!!!!!!!! ['__class__', '__delattr__', '__dict__', '__doc__', '__eq__', '__format__', '__getattribute__', '__hash__', '__init__', '__module__', '__ne__', '__new__', '__reduce__', '__reduce_ex__', '__repr__', '__setattr__', '__sizeof__', '__str__', '__subclasshook__', '__weakref__', '_parsed_fields', 'constants', 'fields', 'full_name', 'has_header', 'header_present', 'names', 'package', 'parsed_fields', 'short_name', 'text', 'types']




template <class ContainerAllocator>
struct IsFixedSize< ::wireless_msgs::Scan_<ContainerAllocator> >
  : FalseType
  { };

template <class ContainerAllocator>
struct IsFixedSize< ::wireless_msgs::Scan_<ContainerAllocator> const>
  : FalseType
  { };

template <class ContainerAllocator>
struct IsMessage< ::wireless_msgs::Scan_<ContainerAllocator> >
  : TrueType
  { };

template <class ContainerAllocator>
struct IsMessage< ::wireless_msgs::Scan_<ContainerAllocator> const>
  : TrueType
  { };

template <class ContainerAllocator>
struct HasHeader< ::wireless_msgs::Scan_<ContainerAllocator> >
  : FalseType
  { };

template <class ContainerAllocator>
struct HasHeader< ::wireless_msgs::Scan_<ContainerAllocator> const>
  : FalseType
  { };


template<class ContainerAllocator>
struct MD5Sum< ::wireless_msgs::Scan_<ContainerAllocator> >
{
  static const char* value()
  {
    return "d32911a086af571ae6871a223a6112f0";
  }

  static const char* value(const ::wireless_msgs::Scan_<ContainerAllocator>&) { return value(); }
  static const uint64_t static_value1 = 0xd32911a086af571aULL;
  static const uint64_t static_value2 = 0xe6871a223a6112f0ULL;
};

template<class ContainerAllocator>
struct DataType< ::wireless_msgs::Scan_<ContainerAllocator> >
{
  static const char* value()
  {
    return "wireless_msgs/Scan";
  }

  static const char* value(const ::wireless_msgs::Scan_<ContainerAllocator>&) { return value(); }
};

template<class ContainerAllocator>
struct Definition< ::wireless_msgs::Scan_<ContainerAllocator> >
{
  static const char* value()
  {
    return "Network[] networks\n\
\n\
================================================================================\n\
MSG: wireless_msgs/Network\n\
string type\n\
string essid\n\
string mac\n\
string mode\n\
string frequency\n\
bool encryption\n\
";
  }

  static const char* value(const ::wireless_msgs::Scan_<ContainerAllocator>&) { return value(); }
};

} // namespace message_traits
} // namespace ros

namespace ros
{
namespace serialization
{

  template<class ContainerAllocator> struct Serializer< ::wireless_msgs::Scan_<ContainerAllocator> >
  {
    template<typename Stream, typename T> inline static void allInOne(Stream& stream, T m)
    {
      stream.next(m.networks);
    }

    ROS_DECLARE_ALLINONE_SERIALIZER;
  }; // struct Scan_

} // namespace serialization
} // namespace ros

namespace ros
{
namespace message_operations
{

template<class ContainerAllocator>
struct Printer< ::wireless_msgs::Scan_<ContainerAllocator> >
{
  template<typename Stream> static void stream(Stream& s, const std::string& indent, const ::wireless_msgs::Scan_<ContainerAllocator>& v)
  {
    s << indent << "networks[]" << std::endl;
    for (size_t i = 0; i < v.networks.size(); ++i)
    {
      s << indent << "  networks[" << i << "]: ";
      s << std::endl;
      s << indent;
      Printer< ::wireless_msgs::Network_<ContainerAllocator> >::stream(s, indent + "    ", v.networks[i]);
    }
  }
};

} // namespace message_operations
} // namespace ros

#endif // WIRELESS_MSGS_MESSAGE_SCAN_H
